## waylandpp 0.2.5

=== CMakeLists.txt ===
# Copyright (c) 2014-2019 Philipp Kerling, Nils Christopher Brause, Craig Andrews, Tobias Kortkamp, Balint Reczey
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

project(waylandpp)
cmake_minimum_required(VERSION 3.1)

# packages
include(FindPkgConfig)
include(GNUInstallDirs)
find_package(Doxygen)

# version information
set(WAYLANDPP_VERSION_MAJOR 0)
set(WAYLANDPP_VERSION_MINOR 2)
set(WAYLANDPP_VERSION_PATCH 5)
set(WAYLANDPP_VERSION "${WAYLANDPP_VERSION_MAJOR}.${WAYLANDPP_VERSION_MINOR}.${WAYLANDPP_VERSION_PATCH}")
configure_file(include/wayland-version.hpp.in wayland-version.hpp @ONLY)

# path shorthands
set(INSTALL_FULL_PKGCONFIGDIR "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")
set(INSTALL_FULL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/waylandpp")

# user options
set(BUILD_SCANNER ON CACHE BOOL "whether to build wayland-scanner++")
set(BUILD_LIBRARIES ON CACHE BOOL "whether to build the libraries")
set(BUILD_DOCUMENTATION ${DOXYGEN_FOUND} CACHE BOOL "Create and install the HTML based API documentation (requires Doxygen)")
set(BUILD_EXAMPLES OFF CACHE BOOL "whether to build the examples (requires BUILD_LIBRARIES to be ON)")

# variables for .pc.in files
set(prefix "${CMAKE_INSTALL_PREFIX}")
set(bindir "${CMAKE_INSTALL_FULL_BINDIR}")
set(datarootdir "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
set(pkgdatadir "${INSTALL_FULL_PKGDATADIR}")
set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")

# C++ 11
set(CMAKE_CXX_STANDARD 11)

# build scanner
if(BUILD_SCANNER)
  pkg_check_modules(PUGIXML REQUIRED "pugixml>=1.4")
  add_executable(wayland-scanner++ scanner/scanner.cpp)
  target_link_libraries(wayland-scanner++ ${PUGIXML_LIBRARIES})
  target_compile_options(wayland-scanner++ PUBLIC ${PUGIXML_CFLAGS})
  configure_file(wayland-scanner++.pc.in wayland-scanner++.pc @ONLY)
  install(TARGETS wayland-scanner++ RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/wayland-scanner++.pc" DESTINATION "${INSTALL_FULL_PKGCONFIGDIR}")
endif()

# build libraries
if(BUILD_LIBRARIES)
  # if we are crosscompiling, the scanner has to build and installed already
  if(CMAKE_CROSSCOMPILING OR (NOT BUILD_SCANNER))
    set(WAYLAND_SCANNERPP "WAYLAND_SCANNERPP-NOTFOUND" CACHE FILEPATH "Path to wayland-scanner++")
    if(NOT WAYLAND_SCANNERPP)
      message(SEND_ERROR "If you cross-compile or do not build the scanner, you have to specify the path to a native wayland-scanner++ executable in the WAYLAND_SCANNERPP variable.")
    endif()
  else()
    set(WAYLAND_SCANNERPP wayland-scanner++)
  endif()

  # required libraries
  pkg_check_modules(WAYLAND_CLIENT REQUIRED "wayland-client>=1.11.0")
  pkg_check_modules(WAYLAND_EGL REQUIRED wayland-egl)
  pkg_check_modules(WAYLAND_CURSOR REQUIRED wayland-cursor)

  # generate protocol source/headers from protocol XMLs
  set(PROTO_XMLS "${CMAKE_SOURCE_DIR}/protocols/wayland.xml")
  file(GLOB PROTO_XMLS_EXTRA "${CMAKE_SOURCE_DIR}/protocols/extra/*.xml")
  file(GLOB PROTO_XMLS_UNSTABLE "${CMAKE_SOURCE_DIR}/protocols/unstable/*.xml")
  set(PROTO_FILES
    "wayland-client-protocol.hpp"
    "wayland-client-protocol.cpp")
  set(PROTO_FILES_EXTRA
    "wayland-client-protocol-extra.hpp"
    "wayland-client-protocol-extra.cpp")
  set(PROTO_FILES_UNSTABLE
    "wayland-client-protocol-unstable.hpp"
    "wayland-client-protocol-unstable.cpp")
  add_custom_command(
    OUTPUT ${PROTO_FILES}
    COMMAND "${WAYLAND_SCANNERPP}" ${PROTO_XMLS} ${PROTO_FILES}
    DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS})
  add_custom_command(
    OUTPUT ${PROTO_FILES_EXTRA}
    COMMAND "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_EXTRA} ${PROTO_FILES_EXTRA}
    DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_EXTRA})
  add_custom_command(
    OUTPUT ${PROTO_FILES_UNSTABLE}
    COMMAND "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_UNSTABLE} "-x" "wayland-client-protocol-extra.hpp"
    DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_EXTRA})

  # library building helper functions
  function(define_library TARGET CFLAGS LDFLAGS HEADERS)
    add_library("${TARGET}" SHARED ${ARGN})
    target_include_directories("${TARGET}" PUBLIC "include" "${CMAKE_CURRENT_BINARY_DIR}") # latter for wayland-version.hpp
    target_compile_options("${TARGET}" PUBLIC ${CFLAGS})
    target_link_libraries("${TARGET}" ${LDFLAGS})
    set_target_properties("${TARGET}" PROPERTIES
      PUBLIC_HEADER "${HEADERS}"
      VERSION "${WAYLANDPP_VERSION_MAJOR}.${WAYLANDPP_VERSION_MINOR}.${WAYLANDPP_VERSION_PATCH}"
      SOVERSION ${WAYLANDPP_VERSION_MAJOR})
    configure_file("${TARGET}.pc.in" "${TARGET}.pc" @ONLY)
    set_target_properties("${TARGET}" PROPERTIES RESOURCE "${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc")
  endfunction()

  define_library(wayland-client++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LDFLAGS}"
    "include/wayland-client.hpp;include/wayland-util.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-version.hpp"
    src/wayland-client.cpp src/wayland-util.cpp wayland-client-protocol.cpp wayland-client-protocol.hpp)
  define_library(wayland-client-extra++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LDFLAGS}"
    "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-extra.hpp"
    wayland-client-protocol-extra.cpp wayland-client-protocol-extra.hpp wayland-client-protocol.hpp)
  define_library(wayland-client-unstable++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LDFLAGS}"
    "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-unstable.hpp"
    wayland-client-protocol-unstable.cpp wayland-client-protocol-unstable.hpp wayland-client-protocol.hpp)
  define_library(wayland-egl++ "${WAYLAND_EGL_CFLAGS}" "${WAYLAND_EGL_LDFLAGS}" include/wayland-egl.hpp src/wayland-egl.cpp wayland-client-protocol.hpp)
  define_library(wayland-cursor++ "${WAYLAND_CURSOR_CFLAGS}" "${WAYLAND_CURSOR_LDFLAGS}" include/wayland-cursor.hpp src/wayland-cursor.cpp wayland-client-protocol.hpp)

  # Install libraries
  install(FILES ${PROTO_XMLS} ${PROTO_XMLS_EXTRA} ${PROTO_XMLS_UNSTABLE} DESTINATION "${INSTALL_FULL_PKGDATADIR}/protocols")
  install(TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++
    LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}"
    RESOURCE DESTINATION "${INSTALL_FULL_PKGCONFIGDIR}")
endif()

if(BUILD_EXAMPLES)
  if(NOT BUILD_LIBRARIES)
    message(FATAL_ERROR "Cannot build examples without building libraries")
  endif()
  add_subdirectory(example)
endif()

if(BUILD_DOCUMENTATION)
  if(NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
  endif()

  set(WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/doc")
  set(WAYLANDPP_BUILD_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  configure_file(Doxyfile.in Doxyfile @ONLY)

  add_custom_command(
    OUTPUT "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/html/index.html"
    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" ${PROTO_FILES} ${PROTO_FILES_EXTRA} ${PROTO_FILES_UNSTABLE}
    COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
    COMMENT "Generating API documentation with Doxygen"
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
    VERBATIM
  )
  add_custom_target(doc ALL DEPENDS "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/html/index.html")

  install(DIRECTORY "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/man/" DESTINATION ${CMAKE_INSTALL_FULL_MANDIR})
  install(DIRECTORY "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/html" "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/latex" DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})
endif()

=== example/CMakeLists.txt ===
# Copyright (c) 2014-2019 Philipp Kerling, Nils Christopher Brause
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# dependencies
find_package(Threads REQUIRED)
find_package(OpenGL REQUIRED)
include(FindPkgConfig)
pkg_check_modules(EGL REQUIRED egl)
find_library(LIBRT rt)
mark_as_advanced(LIBRT)

# examples
add_executable(dump dump.cpp)
target_link_libraries(dump wayland-client++)

add_executable(egl egl.cpp)
target_link_libraries(egl wayland-client++ wayland-client-extra++ wayland-cursor++ wayland-egl++ "${OPENGL_gl_LIBRARY}" ${EGL_LDFLAGS})
target_include_directories(egl PUBLIC "${OPENGL_INCLUDE_DIR}")
target_compile_options(egl PUBLIC ${EGL_CFLAGS})

add_executable(foreign_display foreign_display.cpp)
target_link_libraries(foreign_display wayland-client++)

add_executable(proxy_wrapper proxy_wrapper.cpp)
target_link_libraries(proxy_wrapper wayland-client++ Threads::Threads)

add_executable(shm shm.cpp)
target_link_libraries(shm wayland-client++ wayland-client-extra++ wayland-cursor++)
if(LIBRT)
  target_link_libraries(shm "${LIBRT}")
endif()

=== example/Makefile ===
# Copyright (c) 2014-2019 Nils Christopher Brause, Philipp Kerling
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

CXX = g++
CXXFLAGS = -std=c++11 -Wall -Werror -ggdb -O2 `pkg-config --cflags --libs ${LIBS}`
SRC = egl.cpp shm.cpp dump.cpp proxy_wrapper.cpp foreign_display.cpp

all: $(patsubst %.cpp,%,${SRC})

egl: LIBS = wayland-client++ wayland-client-extra++ wayland-cursor++ wayland-egl++
egl: FLAGS = -lEGL -lGL
shm: LIBS = wayland-client++ wayland-client-extra++ wayland-cursor++
shm: FLAGS = -lrt
dump: LIBS = wayland-client++
proxy_wrapper: LIBS = wayland-client++
proxy_wrapper: FLAGS = -pthread
foreign_display: LIBS = wayland-client++

%: %.cpp Makefile
	${CXX} $< ${CXXFLAGS} ${FLAGS} -o $@

clean: Makefile
	rm -f $(patsubst %.cpp,%,${SRC})

.SUFFIXES:

=== debian/changelog ===
waylandpp (0.2.5-2~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 10 Feb 2020 12:07:09 -0800

waylandpp (0.2.5-2) unstable; urgency=medium

  [ Balint Reczey ]
  * Update symbols file(s)

  [ Helmut Grohne ]
  * Fix FTBFS: Mark a template symbol as optional
  * Fix FTCBFS: Pass a WAYLAND_SCANNERPP to cmake. (Closes: #946078)

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 18 Dec 2019 15:40:57 +0100

waylandpp (0.2.5-1) unstable; urgency=medium

  * debian/control: Setting myself as the Maintainer to get notified about bugs.
    Thanks to Wolfgang Schupp for the initial packaging
  * Clean up symbols files manually

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 04 Jun 2019 13:39:25 +0200

waylandpp (0.2.5-1~exp2) experimental; urgency=medium

  * Create symbols files with amd64 symbols
  * Build-depend on pkg-kde-tools and use pkgkde-symbolshelper in the build

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 03 Jun 2019 23:40:23 +0200

waylandpp (0.2.5-1~exp1) experimental; urgency=medium

  [ Balint Reczey ]
  * Drop template-only packaging files
  * Packaging is in 3.0 (quilt) format
  * Bump compat level to 12
  * Fix debian/copyright
  * debian/rules: Drop templates
  * debian/control:
    - Extend descriptions
    - wayland-scanner++ is Multiarch: allowed
    - Tidy up using cme fix
    - Point Vcs-* to Salsa
    - Add myself as uploader
  * Fix building unstable protocols
  * Append major SO version to library package names
  * Make the -dev package depend on libraries of the same binary version
  * Fix library SO versioning
  * First upload to Debian (Closes: #922522)
  * Add symbols files
  * Add Salsa CI configuration
  * Fix package descriptions
  * Fix debian/copyright
  * New upstream version 0.2.5
  * Drop obsolete patches
  * Update copyright

  [ wsnipex ]
  * Initial packaging

 -- Balint Reczey <rbalint@ubuntu.com>  Sun, 24 Feb 2019 21:41:19 +0100

=== debian/control ===
Source: waylandpp
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Balint Reczey <rbalint@ubuntu.com>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               pkg-config,
               pkg-kde-tools,
               libpugixml-dev (>= 1.9),
               libwayland-dev,
               libwayland-egl1-mesa,
               libegl1-mesa-dev,
               wayland-scanner++:any <cross>,
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/rbalint/waylandpp
Vcs-Git: https://salsa.debian.org/rbalint/waylandpp.git
Homepage: https://github.com/NilsBrause/waylandpp

Package: waylandpp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libwayland-client++0 (= ${binary:Version}),
         libwayland-client-extra++0 (= ${binary:Version}),
         libwayland-cursor++0 (= ${binary:Version}),
         libwayland-egl++0(= ${binary:Version}),
         wayland-scanner++:any (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: wayland compositor infrastructure - C++ development files
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the development libraries.

Package: wayland-scanner++
Architecture: any
Multi-Arch: allowed
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: wayland compositor infrastructure - C++ protocol code generator
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ code generator binary.

Package: libwayland-client++0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: wayland compositor infrastructure - client library C++ bindings
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the client side library of
 the Wayland protocol.

Package: libwayland-client-extra++0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: wayland compositor infrastructure - client library extra C++ bindings
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the client side libraries of
 the extra Wayland protocols.

Package: libwayland-cursor++0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: wayland compositor infrastructure - cursor library C++ bindings
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the library of
 the Wayland protocol to manage cursors.

Package: libwayland-egl++0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: wayland compositor infrastructure - EGL library C++ bindings
 Wayland is a protocol for a compositor to talk to its clients as well
 as a C library implementation of that protocol. The compositor can be
 a standalone display server running on Linux kernel modesetting and
 evdev input devices, an X application, or a wayland client
 itself. The clients can be traditional applications, X servers
 (rootless or fullscreen) or other display servers.
 .
 This package ships the C++ bindings for the library which implements the
 Wayland EGL platform of the Wayland protocol.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with pkgkde_symbolshelper

ifneq (,$(filter cross,$(DEB_BUILD_PROFILES)))
override_dh_auto_configure:
	dh_auto_configure -- -DWAYLAND_SCANNERPP=$(shell which wayland-scanner++)
endif

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## waylandpp 0.2.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,19 +21,17 @@
 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-project(waylandpp)
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.4)
+project(waylandpp VERSION 0.2.8 LANGUAGES CXX)
 
 # packages
 include(FindPkgConfig)
 include(GNUInstallDirs)
+include(CMakeDependentOption)
+include(CMakePackageConfigHelpers)
 find_package(Doxygen)
 
 # version information
-set(WAYLANDPP_VERSION_MAJOR 0)
-set(WAYLANDPP_VERSION_MINOR 2)
-set(WAYLANDPP_VERSION_PATCH 5)
-set(WAYLANDPP_VERSION "${WAYLANDPP_VERSION_MAJOR}.${WAYLANDPP_VERSION_MINOR}.${WAYLANDPP_VERSION_PATCH}")
 configure_file(include/wayland-version.hpp.in wayland-version.hpp @ONLY)
 
 # path shorthands
@@ -41,10 +39,19 @@
 set(INSTALL_FULL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/waylandpp")
 
 # user options
-set(BUILD_SCANNER ON CACHE BOOL "whether to build wayland-scanner++")
-set(BUILD_LIBRARIES ON CACHE BOOL "whether to build the libraries")
-set(BUILD_DOCUMENTATION ${DOXYGEN_FOUND} CACHE BOOL "Create and install the HTML based API documentation (requires Doxygen)")
-set(BUILD_EXAMPLES OFF CACHE BOOL "whether to build the examples (requires BUILD_LIBRARIES to be ON)")
+option(BUILD_SCANNER "whether to build wayland-scanner++" ON)
+option(BUILD_LIBRARIES "whether to build the libraries" ON)
+cmake_dependent_option(BUILD_SHARED_LIBS "Build shared libraries" ON
+  "BUILD_LIBRARIES" OFF)
+option(BUILD_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})
+cmake_dependent_option(BUILD_EXAMPLES
+  "whether to build the examples (requires BUILD_LIBRARIES to be ON)" OFF
+  "BUILD_LIBRARIES" OFF)
+
+# Do not report undefined references in libraries, since the protocol libraries cannot be used on their own.
+if(CMAKE_SHARED_LINKER_FLAGS)
+  string(REPLACE "-Wl,--no-undefined" " " CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS})
+endif()
 
 # variables for .pc.in files
 set(prefix "${CMAKE_INSTALL_PREFIX}")
@@ -54,12 +61,28 @@
 set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
 set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
 
+set(install_namespace "Waylandpp")
+
 # C++ 11
 set(CMAKE_CXX_STANDARD 11)
+
+# sets ${PREFIX}_LIBRARIES to the libraries' full path
+function(pkg_libs_full_path PREFIX)
+  if(${PREFIX}_FOUND)
+    unset(LIBS_TMP CACHE)
+    foreach(LIB ${${PREFIX}_LIBRARIES})
+      unset(LIB_TMP CACHE)
+      find_library(LIB_TMP ${LIB} PATHS ${${PREFIX}_LIBRARY_DIRS})
+      list(APPEND LIBS_TMP ${LIB_TMP})
+    endforeach()
+    set(${PREFIX}_LIBRARIES ${LIBS_TMP} PARENT_SCOPE)
+  endif()
+endfunction()
 
 # build scanner
 if(BUILD_SCANNER)
   pkg_check_modules(PUGIXML REQUIRED "pugixml>=1.4")
+  pkg_libs_full_path(PUGIXML)
   add_executable(wayland-scanner++ scanner/scanner.cpp)
   target_link_libraries(wayland-scanner++ ${PUGIXML_LIBRARIES})
   target_compile_options(wayland-scanner++ PUBLIC ${PUGIXML_CFLAGS})
@@ -82,8 +105,11 @@
 
   # required libraries
   pkg_check_modules(WAYLAND_CLIENT REQUIRED "wayland-client>=1.11.0")
+  pkg_libs_full_path(WAYLAND_CLIENT)
   pkg_check_modules(WAYLAND_EGL REQUIRED wayland-egl)
+  pkg_libs_full_path(WAYLAND_EGL)
   pkg_check_modules(WAYLAND_CURSOR REQUIRED wayland-cursor)
+  pkg_libs_full_path(WAYLAND_CURSOR)
 
   # generate protocol source/headers from protocol XMLs
   set(PROTO_XMLS "${CMAKE_SOURCE_DIR}/protocols/wayland.xml")
@@ -112,37 +138,67 @@
     DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_EXTRA})
 
   # library building helper functions
-  function(define_library TARGET CFLAGS LDFLAGS HEADERS)
-    add_library("${TARGET}" SHARED ${ARGN})
-    target_include_directories("${TARGET}" PUBLIC "include" "${CMAKE_CURRENT_BINARY_DIR}") # latter for wayland-version.hpp
+  function(define_library TARGET CFLAGS LIBRARIES HEADERS)
+    add_library("${TARGET}" ${ARGN})
+    add_library(${install_namespace}::${TARGET} ALIAS ${TARGET})
+    get_target_property(libtype "${TARGET}" TYPE)
+    target_include_directories("${TARGET}" PUBLIC
+      $<BUILD_INTERFACE:include;${CMAKE_CURRENT_BINARY_DIR}> # latter for wayland-version.hpp
+      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+      )
     target_compile_options("${TARGET}" PUBLIC ${CFLAGS})
-    target_link_libraries("${TARGET}" ${LDFLAGS})
+    target_link_libraries("${TARGET}" PUBLIC ${LIBRARIES})
     set_target_properties("${TARGET}" PROPERTIES
       PUBLIC_HEADER "${HEADERS}"
-      VERSION "${WAYLANDPP_VERSION_MAJOR}.${WAYLANDPP_VERSION_MINOR}.${WAYLANDPP_VERSION_PATCH}"
-      SOVERSION ${WAYLANDPP_VERSION_MAJOR})
+      VERSION "${PROJECT_VERSION}"
+      SOVERSION ${PROJECT_VERSION_MAJOR})
     configure_file("${TARGET}.pc.in" "${TARGET}.pc" @ONLY)
     set_target_properties("${TARGET}" PROPERTIES RESOURCE "${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc")
   endfunction()
 
-  define_library(wayland-client++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LDFLAGS}"
+  define_library(wayland-client++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
     "include/wayland-client.hpp;include/wayland-util.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-version.hpp"
     src/wayland-client.cpp src/wayland-util.cpp wayland-client-protocol.cpp wayland-client-protocol.hpp)
-  define_library(wayland-client-extra++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LDFLAGS}"
+  # Report undefined references only for the base library.
+  if(${CMAKE_VERSION} VERSION_GREATER "3.14.0")
+    target_link_options(wayland-client++ PRIVATE "-Wl,--no-undefined")
+  endif()
+  define_library(wayland-client-extra++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
     "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-extra.hpp"
     wayland-client-protocol-extra.cpp wayland-client-protocol-extra.hpp wayland-client-protocol.hpp)
-  define_library(wayland-client-unstable++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LDFLAGS}"
+  target_link_libraries(wayland-client-extra++ INTERFACE wayland-client++)
+  define_library(wayland-client-unstable++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
     "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-unstable.hpp"
     wayland-client-protocol-unstable.cpp wayland-client-protocol-unstable.hpp wayland-client-protocol.hpp)
-  define_library(wayland-egl++ "${WAYLAND_EGL_CFLAGS}" "${WAYLAND_EGL_LDFLAGS}" include/wayland-egl.hpp src/wayland-egl.cpp wayland-client-protocol.hpp)
-  define_library(wayland-cursor++ "${WAYLAND_CURSOR_CFLAGS}" "${WAYLAND_CURSOR_LDFLAGS}" include/wayland-cursor.hpp src/wayland-cursor.cpp wayland-client-protocol.hpp)
+  target_link_libraries(wayland-client-unstable++ INTERFACE wayland-client-extra++)
+  define_library(wayland-egl++ "${WAYLAND_EGL_CFLAGS}" "${WAYLAND_EGL_LIBRARIES}" include/wayland-egl.hpp src/wayland-egl.cpp wayland-client-protocol.hpp)
+  target_link_libraries(wayland-egl++ INTERFACE wayland-client++)
+  define_library(wayland-cursor++ "${WAYLAND_CURSOR_CFLAGS}" "${WAYLAND_CURSOR_LIBRARIES}" include/wayland-cursor.hpp src/wayland-cursor.cpp wayland-client-protocol.hpp)
+  target_link_libraries(wayland-cursor++ INTERFACE wayland-client++)
 
   # Install libraries
   install(FILES ${PROTO_XMLS} ${PROTO_XMLS_EXTRA} ${PROTO_XMLS_UNSTABLE} DESTINATION "${INSTALL_FULL_PKGDATADIR}/protocols")
-  install(TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++
+  install(TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++ EXPORT ${CMAKE_PROJECT_NAME}-targets
     LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
+    ARCHIVE DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
     PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}"
     RESOURCE DESTINATION "${INSTALL_FULL_PKGCONFIGDIR}")
+
+  # create and install CMake-Config files
+  set(_CMAKECONFIGDIR "${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME}")
+
+  install(EXPORT ${CMAKE_PROJECT_NAME}-targets
+        DESTINATION "${_CMAKECONFIGDIR}"
+        NAMESPACE ${install_namespace}::)
+  write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config-version.cmake
+    COMPATIBILITY AnyNewerVersion)
+  configure_package_config_file(waylandpp-config.cmake.in
+                              ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config.cmake
+                              INSTALL_DESTINATION "${_CMAKECONFIGDIR}")
+
+  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config-version.cmake
+                ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config.cmake
+          DESTINATION "${_CMAKECONFIGDIR}")
 endif()
 
 if(BUILD_EXAMPLES)

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,7 @@
 target_link_libraries(dump wayland-client++)
 
 add_executable(egl egl.cpp)
-target_link_libraries(egl wayland-client++ wayland-client-extra++ wayland-cursor++ wayland-egl++ "${OPENGL_gl_LIBRARY}" ${EGL_LDFLAGS})
+target_link_libraries(egl wayland-client++ wayland-client-extra++ wayland-cursor++ wayland-egl++ "${OPENGL_LIBRARY}" ${EGL_LDFLAGS})
 target_include_directories(egl PUBLIC "${OPENGL_INCLUDE_DIR}")
 target_compile_options(egl PUBLIC ${EGL_CFLAGS})

=== debian/changelog ===
waylandpp (0.2.8-2) unstable; urgency=medium

  * Orphaning the package
  * debian/control: Move packaging under the Debian project on Salsa
  * debian/watch: Fix pattern

 -- Balint Reczey <balint@balintreczey.hu>  Fri, 14 Jan 2022 20:05:05 +0100

waylandpp (0.2.8-1) unstable; urgency=medium

  * ACK NMU, thanks Christian for the fix
  * New upstream version 0.2.8
  * Drop symbols files in favor of using shlibs files
  * Drop 01_FTBFS-gcc-10.patch merged upstream

 -- Balint Reczey <rbalint@ubuntu.com>  Sat, 08 Aug 2020 17:56:52 +0200

waylandpp (0.2.5-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with gcc 10 (Gentoo patch) (CLoses: #957924)

 -- Christian Marillat <marillat@debian.org>  Tue, 28 Jul 2020 23:38:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,19 @@
 Source: waylandpp
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Balint Reczey <rbalint@ubuntu.com>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 12),
                cmake,
                pkg-config,
                pkg-kde-tools,
-               libpugixml-dev (>= 1.9),
+               libpugixml-dev,
                libwayland-dev,
                libwayland-egl1-mesa,
                libegl1-mesa-dev,
                wayland-scanner++:any <cross>,
 Standards-Version: 4.3.0
-Vcs-Browser: https://salsa.debian.org/rbalint/waylandpp
-Vcs-Git: https://salsa.debian.org/rbalint/waylandpp.git
+Vcs-Browser: https://salsa.debian.org/debian/waylandpp
+Vcs-Git: https://salsa.debian.org/debian/waylandpp.git
 Homepage: https://github.com/NilsBrause/waylandpp
 
 Package: waylandpp-dev

## waylandpp 0.2.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2014-2019 Philipp Kerling, Nils Christopher Brause, Craig Andrews, Tobias Kortkamp, Balint Reczey
+# Copyright (c) 2014-2022 Philipp Kerling, Nils Christopher Brause, Craig Andrews, Tobias Kortkamp, Balint Reczey
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -22,7 +22,7 @@
 # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 cmake_minimum_required(VERSION 3.4)
-project(waylandpp VERSION 0.2.8 LANGUAGES CXX)
+project(waylandpp VERSION 0.2.10 LANGUAGES CXX)
 
 # packages
 include(FindPkgConfig)
@@ -44,6 +44,7 @@
 cmake_dependent_option(BUILD_SHARED_LIBS "Build shared libraries" ON
   "BUILD_LIBRARIES" OFF)
 option(BUILD_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})
+option(INSTALL_UNSTABLE_PROTOCOLS "whether to install the unstable protocols" ON)
 cmake_dependent_option(BUILD_EXAMPLES
   "whether to build the examples (requires BUILD_LIBRARIES to be ON)" OFF
   "BUILD_LIBRARIES" OFF)
@@ -78,6 +79,10 @@
     set(${PREFIX}_LIBRARIES ${LIBS_TMP} PARENT_SCOPE)
   endif()
 endfunction()
+
+# AdressSanitizer support
+set(CMAKE_C_FLAGS_ASAN "-fsanitize=address -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O0")
+set(CMAKE_CXX_FLAGS_ASAN "-fsanitize=address -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O0")
 
 # build scanner
 if(BUILD_SCANNER)
@@ -178,7 +183,11 @@
 
   # Install libraries
   install(FILES ${PROTO_XMLS} ${PROTO_XMLS_EXTRA} ${PROTO_XMLS_UNSTABLE} DESTINATION "${INSTALL_FULL_PKGDATADIR}/protocols")
-  install(TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++ EXPORT ${CMAKE_PROJECT_NAME}-targets
+  list(APPEND INSTALL_TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++)
+  if (INSTALL_UNSTABLE_PROTOCOLS)
+	  list(APPEND INSTALL_TARGETS wayland-client-unstable++)
+  endif()
+  install(TARGETS ${INSTALL_TARGETS} EXPORT ${CMAKE_PROJECT_NAME}-targets
     LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
     ARCHIVE DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
     PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}"

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2014-2019 Philipp Kerling, Nils Christopher Brause
+# Copyright (c) 2014-2022 Philipp Kerling, Nils Christopher Brause
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without

=== example/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2014-2019 Nils Christopher Brause, Philipp Kerling
+# Copyright (c) 2014-2022 Nils Christopher Brause, Philipp Kerling
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without

=== debian/changelog ===
waylandpp (0.2.10-1) unstable; urgency=medium

  * New upstream version 0.2.10, Closes: #1006812
  * added a build-dependency on doxygen

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 16 Apr 2022 15:44:00 +0200

waylandpp (0.2.9-2) unstable; urgency=medium

  * moved "usr/lib/*/cmake/*" to d/not-installed : those files contain
    paths of the build process, which are not reproducible, hence triggering
    errors for the reproducible-build test.

 -- Georges Khaznadar <georgesk@debian.org>  Fri, 04 Mar 2022 11:10:53 +0100

waylandpp (0.2.9-1) unstable; urgency=medium

  * adopted the package. Closes: #1003739
  * new upstream version
  * bumped Standards-Version: 4.6.0.2, debhelper-compat (= 13)
  * fixed d/waylandpp-dev.install for missing files reported by dh_missing;
    added usr/lib/*/libwayland-client-unstable++.so.* to a new file
    d/not-installed

 -- Georges Khaznadar <georgesk@debian.org>  Thu, 03 Mar 2022 17:53:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: waylandpp
-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Georges Khaznadar <georgesk@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                pkg-config,
                pkg-kde-tools,
@@ -11,7 +11,8 @@
                libwayland-egl1-mesa,
                libegl1-mesa-dev,
                wayland-scanner++:any <cross>,
-Standards-Version: 4.3.0
+	       doxygen,
+Standards-Version: 4.6.0.2
 Vcs-Browser: https://salsa.debian.org/debian/waylandpp
 Vcs-Git: https://salsa.debian.org/debian/waylandpp.git
 Homepage: https://github.com/NilsBrause/waylandpp

## waylandpp 1.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 cmake_minimum_required(VERSION 3.4)
-project(waylandpp VERSION 0.2.10 LANGUAGES CXX)
+project(waylandpp VERSION 1.0.0 LANGUAGES CXX)
 
 # packages
 include(FindPkgConfig)
@@ -48,6 +48,7 @@
 cmake_dependent_option(BUILD_EXAMPLES
   "whether to build the examples (requires BUILD_LIBRARIES to be ON)" OFF
   "BUILD_LIBRARIES" OFF)
+option(BUILD_SERVER "whether to build the server bindings." ON)
 
 # Do not report undefined references in libraries, since the protocol libraries cannot be used on their own.
 if(CMAKE_SHARED_LINKER_FLAGS)
@@ -110,7 +111,9 @@
 
   # required libraries
   pkg_check_modules(WAYLAND_CLIENT REQUIRED "wayland-client>=1.11.0")
-  pkg_libs_full_path(WAYLAND_CLIENT)
+  if(BUILD_SERVER)
+    pkg_check_modules(WAYLAND_SERVER REQUIRED "wayland-server>=1.17.0")
+  endif()
   pkg_check_modules(WAYLAND_EGL REQUIRED wayland-egl)
   pkg_libs_full_path(WAYLAND_EGL)
   pkg_check_modules(WAYLAND_CURSOR REQUIRED wayland-cursor)
@@ -142,6 +145,30 @@
     COMMAND "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_UNSTABLE} "-x" "wayland-client-protocol-extra.hpp"
     DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_EXTRA})
 
+  if(BUILD_SERVER)
+    set(PROTO_FILES
+      "wayland-server-protocol.hpp"
+      "wayland-server-protocol.cpp")
+    set(PROTO_FILES_EXTRA
+      "wayland-server-protocol-extra.hpp"
+      "wayland-server-protocol-extra.cpp")
+    set(PROTO_FILES_UNSTABLE
+      "wayland-server-protocol-unstable.hpp"
+      "wayland-server-protocol-unstable.cpp")
+    add_custom_command(
+      OUTPUT ${PROTO_FILES}
+      COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XMLS} ${PROTO_FILES}
+      DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS})
+    add_custom_command(
+      OUTPUT ${PROTO_FILES_EXTRA}
+      COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XMLS_EXTRA} ${PROTO_FILES_EXTRA} "-x" "wayland-server-protocol.hpp"
+      DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_EXTRA})
+    add_custom_command(
+      OUTPUT ${PROTO_FILES_UNSTABLE}
+      COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_UNSTABLE} "-x" "wayland-server-protocol-extra.hpp"
+      DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_EXTRA})
+  endif()
+
   # library building helper functions
   function(define_library TARGET CFLAGS LIBRARIES HEADERS)
     add_library("${TARGET}" ${ARGN})
@@ -168,6 +195,23 @@
   if(${CMAKE_VERSION} VERSION_GREATER "3.14.0")
     target_link_options(wayland-client++ PRIVATE "-Wl,--no-undefined")
   endif()
+  if(BUILD_SERVER)
+    define_library(wayland-server++ "${WAYLAND_SERVER_CFLAGS}" "${WAYLAND_SERVER_LIBRARIES}"
+      "include/wayland-server.hpp;include/wayland-util.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-server-protocol.hpp"
+      src/wayland-server.cpp src/wayland-util.cpp wayland-server-protocol.cpp wayland-server-protocol.hpp)
+    # Report undefined references only for the base library.
+    if(${CMAKE_VERSION} VERSION_GREATER "3.14.0")
+      target_link_options(wayland-server++ PRIVATE "-Wl,--no-undefined")
+    endif()
+    define_library(wayland-server-extra++ "${WAYLAND_SERVER_CFLAGS}" "${WAYLAND_SERVER_LIBRARIES}"
+      "${CMAKE_CURRENT_BINARY_DIR}/wayland-server-protocol-extra.hpp"
+      wayland-server-protocol-extra.cpp wayland-server-protocol-extra.hpp wayland-server-protocol.hpp)
+    target_link_libraries(wayland-server-extra++ INTERFACE wayland-server++)
+    define_library(wayland-server-unstable++ "${WAYLAND_SERVER_CFLAGS}" "${WAYLAND_SERVER_LIBRARIES}"
+      "${CMAKE_CURRENT_BINARY_DIR}/wayland-server-protocol-unstable.hpp"
+      wayland-server-protocol-unstable.cpp wayland-server-protocol-unstable.hpp wayland-server-protocol.hpp)
+    target_link_libraries(wayland-server-unstable++ INTERFACE wayland-server-extra++)
+  endif()
   define_library(wayland-client-extra++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
     "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-extra.hpp"
     wayland-client-protocol-extra.cpp wayland-client-protocol-extra.hpp wayland-client-protocol.hpp)
@@ -186,56 +230,8 @@
   list(APPEND INSTALL_TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++)
   if (INSTALL_UNSTABLE_PROTOCOLS)
 	  list(APPEND INSTALL_TARGETS wayland-client-unstable++)
-  endif()
-  install(TARGETS ${INSTALL_TARGETS} EXPORT ${CMAKE_PROJECT_NAME}-targets
-    LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
-    ARCHIVE DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
-    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}"
-    RESOURCE DESTINATION "${INSTALL_FULL_PKGCONFIGDIR}")
-
-  # create and install CMake-Config files
-  set(_CMAKECONFIGDIR "${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME}")
-
-  install(EXPORT ${CMAKE_PROJECT_NAME}-targets
-        DESTINATION "${_CMAKECONFIGDIR}"
-        NAMESPACE ${install_namespace}::)
-  write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config-version.cmake
-    COMPATIBILITY AnyNewerVersion)
-  configure_package_config_file(waylandpp-config.cmake.in
-                              ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config.cmake
-                              INSTALL_DESTINATION "${_CMAKECONFIGDIR}")
-
-  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config-version.cmake
-                ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config.cmake
-          DESTINATION "${_CMAKECONFIGDIR}")
-endif()
-
-if(BUILD_EXAMPLES)
-  if(NOT BUILD_LIBRARIES)
-    message(FATAL_ERROR "Cannot build examples without building libraries")
-  endif()
-  add_subdirectory(example)
-endif()
-
-if(BUILD_DOCUMENTATION)
-  if(NOT DOXYGEN_FOUND)
-    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
-  endif()
-
-  set(WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/doc")
-  set(WAYLANDPP_BUILD_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
-  configure_file(Doxyfile.in Doxyfile @ONLY)
-
-  add_custom_command(
-    OUTPUT "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/html/index.html"
-    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" ${PROTO_FILES} ${PROTO_FILES_EXTRA} ${PROTO_FILES_UNSTABLE}
-    COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
-    COMMENT "Generating API documentation with Doxygen"
-    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
-    VERBATIM
-  )
-  add_custom_target(doc ALL DEPENDS "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/html/index.html")
-
-  install(DIRECTORY "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/man/" DESTINATION ${CMAKE_INSTALL_FULL_MANDIR})
-  install(DIRECTORY "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/html" "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/latex" DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})
-endif()
+    if(BUILD_SERVER)
+	    list(APPEND INSTALL_TARGETS wayland-server-unstable++)
+    endif()
+  endif()
+  if(BUILD_SERVER)

=== debian/changelog ===
waylandpp (1.0.0-6) unstable; urgency=medium

  * replaced a build-dependency: libwayland-egl1-mesa -> libegl1
  Closes: #1070062

 -- Georges Khaznadar <georgesk@debian.org>  Wed, 01 May 2024 19:27:19 +0200

waylandpp (1.0.0-5) unstable; urgency=medium

  * added '#include <cstdint>' stances. Closes: #1037893

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 17 Jul 2023 19:12:01 +0200

waylandpp (1.0.0-4) unstable; urgency=medium

  * added usr/lib/*/libwayland-client-unstable++.so.* in the file
    d/libwayland-client++1.install, removed it from d/not-installed.
    Closes: #1035462
  * fixed Standards-Version: 4.6.0.2 -> 4.6.2
  * declared libwayland-client-unstable++.so in d/libwayland-client++1.shlib

 -- Georges Khaznadar <georgesk@debian.org>  Wed, 03 May 2023 17:39:41 +0200

waylandpp (1.0.0-3) unstable; urgency=medium

  * Closes: #1011107, thanks to Thadeu Lima de Souza Cascardo;
    added conflict/replace clauses for libraries

 -- Georges Khaznadar <georgesk@debian.org>  Tue, 17 May 2022 09:32:49 +0200

waylandpp (1.0.0-2) unstable; urgency=medium

  * used Vasyl Gello's debdiff, thanks!
    Closes: #1010921
    Closes: #1010956

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 14 May 2022 17:23:01 +0200

waylandpp (1.0.0-1) unstable; urgency=medium

  * new upstream version 1.0.0
  * added the new binary package libwayland-server++0, which contains
    new libraries created upstream
  * created a separate package waylandpp-doc. Closes: #1010087

 -- Georges Khaznadar <georgesk@debian.org>  Fri, 06 May 2022 18:13:23 +0200

=== debian/watch ===
version=4
https://github.com/NilsBrause/waylandpp/tags .*archive/refs/tags/?(\d\S*).*\.tar\.gz
